subroutine bif_neuron_v12_mpi(num_neurons,num_lyapu,RK_method_index_traj,RK_method_index_LEs,system_dim,dim_par,n_step,trans_traj,tam_traj,write_traj_file_switch,write_LEs_file_switch,lyapu_on,seed_ci_initial,param_chem_coupling,param_elec_coupling,dt,t0,r,Theta_syn,V_syn,mult_ci,OP,escolhe_geometria,matriz_acopla_electrical,matriz_acopla_chemical,Ic,char_num_neurons,I_ext_switch,I_ext,I_ext_period,I_ext_amplitude,order_parameter_r_full_network,syncmatrixglobalnetwork,rlink,syncmatrixglobalnetwork_switch,char_param_chem_coupling,char_param_elec_coupling,max_LE_final,char_counter_realization,num_communities,numcom,community,order_parameter_r_communities)
implicit none
integer(kind=4),intent(in)	:: num_neurons,num_lyapu,RK_method_index_traj,RK_method_index_LEs,system_dim,dim_par,n_step,trans_traj,tam_traj,write_traj_file_switch,write_LEs_file_switch,lyapu_on,seed_ci_initial,escolhe_geometria,I_ext_switch,syncmatrixglobalnetwork_switch,num_communities,numcom(num_communities),community(num_communities,maxval(numcom(:)))
integer(kind=4),intent(inout)	:: matriz_acopla_electrical(num_neurons,num_neurons),matriz_acopla_chemical(num_neurons,num_neurons)
real(kind=8),intent(in)		:: param_chem_coupling,param_elec_coupling,dt,t0,r,Theta_syn,V_syn,mult_ci,OP,I_ext,I_ext_period,I_ext_amplitude
real(kind=8),intent(out)	:: Ic,max_LE_final
real(kind=8),intent(inout)	:: order_parameter_r_full_network,syncmatrixglobalnetwork(num_neurons,num_neurons),rlink,order_parameter_r_communities(num_communities)
character*(*),intent(in)	:: char_num_neurons,char_param_chem_coupling,char_param_elec_coupling,char_counter_realization
real(kind=8),allocatable	:: ini2(:,:),lamb_lyap(:),lamb_ordena(:),lamb_positivos(:),matriz_par(:,:),matriz_x(:,:),guarda_x(:),phase(:),Deltaphase(:,:),sumsin(:,:),sumcos(:,:)
real(kind=8)			:: t,sum_pos_LEs,sumcostmp,sumsintmp
integer(kind=4),allocatable	:: matriz_cont(:)
integer(kind=4)			:: num_lyap_positive,conta_grand_lyap,conta_step_lyap,i,j,k,conta_integra

!allocation of matrices
allocate(matriz_par(dim_par,num_neurons),matriz_x(system_dim,num_neurons),guarda_x(num_neurons),matriz_cont(num_neurons))

if (num_lyapu>=1) allocate(ini2(system_dim*num_neurons,num_lyapu))

!allocation of the rest of the matrices
if (num_lyapu>=1) allocate(lamb_lyap(num_lyapu),lamb_ordena(num_lyapu),lamb_positivos(num_lyapu))

allocate(phase(num_neurons))
if (syncmatrixglobalnetwork_switch==1) then
	allocate(Deltaphase(num_neurons,num_neurons),sumsin(num_neurons,num_neurons),sumcos(num_neurons,num_neurons))
	Deltaphase=0.d0
	sumsin=0.d0
	sumcos=0.d0
endif
phase=0.d0
order_parameter_r_communities=0.d0

call initialize_matrices(num_lyapu,system_dim,num_neurons,dim_par,lamb_lyap,lamb_ordena,lamb_positivos,ini2,matriz_par,matriz_x,guarda_x,matriz_cont)

if (I_ext_switch==0) matriz_par(1,:)=I_ext
matriz_par(2,:)=V_syn
matriz_par(3,:)=param_chem_coupling
matriz_par(4,:)=r
matriz_par(5,1)=0.d0 !parameter mismatch
matriz_par(6,:)=Theta_syn

call write_in_file(RK_method_index_traj,RK_method_index_LEs,write_traj_file_switch,write_LEs_file_switch,matriz_par,num_neurons,dim_par,num_lyapu,dt,trans_traj,tam_traj,escolhe_geometria,t0,OP,mult_ci,n_step,lyapu_on,param_chem_coupling,param_elec_coupling,seed_ci_initial,I_ext_switch,I_ext,I_ext_amplitude,num_communities)

!zera matrizes e vetores (inicializa)
if (num_lyapu>=1) call zera_01(num_lyapu,system_dim,num_neurons,ini2)

!gera condicoes iniciais. State vector only
call gera_ci(matriz_x,system_dim,num_neurons,mult_ci)

call create_I_ext_vs_time_plot_gnu_file(tam_traj,dt,I_ext,char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization)

!beginning of integration loop
conta_step_lyap=0
conta_integra=0
conta_grand_lyap=0
order_parameter_r_full_network=0.d0
t=t0
do while (matriz_cont(1)<=tam_traj.and.conta_integra<tam_traj)
	guarda_x(:)=matriz_x(1,:)
	if (I_ext_switch/=0) then
		if (t>=trans_traj*dt) then
			matriz_par(1,:)=I_ext+I_ext_amplitude*dsin(I_ext_period*(t-trans_traj*dt))
		else
			matriz_par(1,:)=I_ext
		endif
	endif
	if (dmod(t,10.d0)<dt) then
		write(17,'(es12.5,f26.16)') t,matriz_par(1,1)
		call flush(17)
	endif

	select case (RK_method_index_traj)
		case (1)
			!1-stage Euler method
			call integra_1(dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,matriz_x,param_elec_coupling,matriz_acopla_chemical,dt)
		case (2)
			!2-stage Heun method (or improved Euler method)
			call integra_2(dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,matriz_x,param_elec_coupling,matriz_acopla_chemical,dt)
		case (3)
			!2-stage Arithmetic Mean Runge - Kutta method (3rd order)
			call integra_3(dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,matriz_x,param_elec_coupling,matriz_acopla_chemical,dt)
		case (4)
			!classical Runge - Kutta method (4th order)
			call integra_4(dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,matriz_x,param_elec_coupling,matriz_acopla_chemical,dt)
	end select

	if (t<dt) then
		if (t==0.d0) then
			write(1,'(" ----------------------------------------------------------------------------------------------------------------------------------")')
			write(*,'(" ----------------------------------------------------------------------------------------------------------------------------------")')
			call flush(1)
		endif
		write(*,'(/," Current integration time: ",es12.5," / ",es12.5)') t,tam_traj*dt
	endif
	if (dmod(t,(tam_traj*dt)/10.d0)<dt.and.t>0.d0) then
		write(*,'(" Current integration time: ",es12.5," / ",es12.5)') t,tam_traj*dt
		call systemqq('gnuplot < ''cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'plot_I_ext_vs_time_nnev12n'//char_num_neurons//'.gnu''')
	endif
	
 	conta_integra=conta_integra+1
 	t=t+dt

	if (write_traj_file_switch/=0.and.conta_integra>trans_traj.and.t<tam_traj*dt) then
		!trajectories of each single neuron
		write(2,'(es12.5,<num_neurons>f26.16)') t,(matriz_x(1,i),i=1,num_neurons) !for p
		call flush(2)
!		write(3,'(es12.5,<num_neurons>f26.16)') t,(matriz_x(2,i),i=1,num_neurons) !for q
!		call flush(3)
!		write(4,'(es12.5,<num_neurons>f26.16)') t,(matriz_x(3,i),i=1,num_neurons) !for n
!		call flush(4)
!		write(5,'(es12.5,<num_neurons>f26.16)') t,(matriz_x(4,i),i=1,num_neurons) !for phase
!		call flush(5)
	endif

	if (t>trans_traj*dt) then
		!according to paper: J. S. Gomez-Gardenes et. al, PLOS ONE, vol. 5, issue 8, e12313, 2010
		!computations of the global network synchronization measure in terms of the phase (for the whole network of num_neurons) ---> matriz_x(4,i),i=1,num_neurons
		!and of the local synchronization of the clusters (pages: 9 - 10)
		phase(:)=matriz_x(4,:)
		order_parameter_r_full_network=order_parameter_r_full_network+dsqrt((sum(dcos(phase(:)))/num_neurons)**2+(sum(dsin(phase(:)))/num_neurons)**2)*dt

		do i=1,num_communities
			sumcostmp=0.d0
			sumsintmp=0.d0
			do j=1,numcom(i)
				sumcostmp=sumcostmp+dcos(phase(community(i,j)))
				sumsintmp=sumsintmp+dsin(phase(community(i,j)))
			enddo
			sumcostmp=sumcostmp/numcom(i)
			sumsintmp=sumsintmp/numcom(i)
		
			order_parameter_r_communities(i)=order_parameter_r_communities(i)+dsqrt(sumcostmp**2+sumsintmp**2)*dt
		enddo

		!order_parameter_r_full_network/(t-trans_traj*dt) is the order parameter of the full network --> order parameter r
		!order_parameter_r_full_network/(t-trans_traj*dt) measures the phase coherence of all neurons of the network
		if (dmod(t,(tam_traj*dt)/100.d0)<dt.and.t>0.d0) then
			write(20,'(es12.5,<1+num_communities>f26.16)') t,order_parameter_r_full_network/(t-trans_traj*dt),(order_parameter_r_communities(i)/(t-trans_traj*dt),i=1,num_communities)
			call flush(20)
		endif
		
		if (syncmatrixglobalnetwork_switch==1) then
			!according to paper: J. S. Gomez-Gardenes et. al, PLOS ONE, vol. 5, issue 8, e12313, 2010
			!computations of the global network synchronization matrix in terms of the phase (for the whole network of num_neurons) ---> matriz_x(4,i),i=1,num_neurons
			do i=1,num_neurons
				do j=1,num_neurons
					Deltaphase(i,j)=phase(i)-phase(j)
					sumcos(i,j)=sumcos(i,j)+dcos(Deltaphase(i,j))*dt
					sumsin(i,j)=sumsin(i,j)+dsin(Deltaphase(i,j))*dt
				enddo
			enddo
		endif
	endif

	if (num_lyapu>=1.and.conta_integra>trans_traj) then
		select case (RK_method_index_LEs)
			case (1)
				!1-stage Euler method
				call calc_lyap_1(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,ini2,dt,matriz_x,conta_grand_lyap,lamb_lyap,n_step,param_elec_coupling,conta_step_lyap,lyapu_on,matriz_acopla_chemical)
			case (2)
				!2-stage Heun method (or improved Euler method)
				call calc_lyap_2(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,ini2,dt,matriz_x,conta_grand_lyap,lamb_lyap,n_step,param_elec_coupling,conta_step_lyap,lyapu_on,matriz_acopla_chemical)
			case (3)
				!2-stage Arithmetic Mean Runge - Kutta method (3rd order)
				call calc_lyap_3(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,ini2,dt,matriz_x,conta_grand_lyap,lamb_lyap,n_step,param_elec_coupling,conta_step_lyap,lyapu_on,matriz_acopla_chemical)
			case (4)
				!classical Runge - Kutta method (4th order)
				call calc_lyap_4(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,ini2,dt,matriz_x,conta_grand_lyap,lamb_lyap,n_step,param_elec_coupling,conta_step_lyap,lyapu_on,matriz_acopla_chemical)
		end select
		if (write_LEs_file_switch/=0.and.mod(conta_integra,n_step)==0) then
			call swap_LEs(num_lyapu,lamb_lyap,lamb_ordena)
			if (conta_grand_lyap-lyapu_on==0) then
				write(6,'(2f26.16,es12.5,<num_lyapu>f26.16)') param_chem_coupling,param_elec_coupling,t,(lamb_ordena(i),i=1,num_lyapu)
				call flush(6)
			else if (conta_grand_lyap-lyapu_on>0) then
				write(6,'(2f26.16,es12.5,<num_lyapu>f26.16)') param_chem_coupling,param_elec_coupling,t,(lamb_ordena(i)/(conta_grand_lyap-lyapu_on),i=1,num_lyapu)
				call flush(6)
			endif
		endif
	endif

	if (conta_integra>trans_traj) then
		do i=1,num_neurons
			if (guarda_x(i)>OP.and.matriz_x(1,i)<OP) matriz_cont(i)=matriz_cont(i)+1
		enddo
	endif
enddo
!end of integration loop

write(20,'(es12.5,<1+num_communities>f26.16)') t,order_parameter_r_full_network/(t-trans_traj*dt),(order_parameter_r_communities(i)/(t-trans_traj*dt),i=1,num_communities)
call flush(20)
		
if (dabs(t-(tam_traj*dt))<dt) then
	write(17,'(es12.5,f26.16)') t,matriz_par(1,1)
	call flush(17)
	write(*,'(" Current integration time: ",es12.5," / ",es12.5)') t,tam_traj*dt
	call systemqq('gnuplot < ''cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'plot_I_ext_vs_time_nnev12n'//char_num_neurons//'.gnu''')
endif

if (dabs(t-tam_traj*dt)<dt) write(*,'(" Current integration time: ",es12.5," / ",es12.5)') t,tam_traj*dt

if (num_lyapu>=1) then
	sum_pos_LEs=0.d0
	num_lyap_positive=0
	if (conta_grand_lyap-lyapu_on>0) lamb_lyap(:)=lamb_lyap(:)/(conta_grand_lyap-lyapu_on)
	call swap_LEs(num_lyapu,lamb_lyap,lamb_ordena)
	if (write_LEs_file_switch/=0) then
		write(6,'(2f26.16,es12.5,<num_lyapu>f26.16)') param_chem_coupling,param_elec_coupling,t,(lamb_ordena(i),i=1,num_lyapu)
		call flush(6)
	endif
	!considera que so existem num_lyapu Lyapunov expoentes positivos
	do i=1,num_lyapu
		if (lamb_lyap(i)>0.d0) then
			num_lyap_positive=num_lyap_positive+1
			sum_pos_LEs=sum_pos_LEs+lamb_lyap(i)
			lamb_positivos(num_lyap_positive)=lamb_lyap(i)
		endif
	enddo
	call swap_LEs(num_lyap_positive,lamb_positivos,lamb_ordena)
	lamb_positivos(1:num_lyap_positive)=lamb_ordena(1:num_lyap_positive)
	if (num_lyap_positive>0) then
		max_LE_final=lamb_positivos(1)
		write(1,'(" Positive Lyapunov exponents ordered:")')
		write(*,'(" Positive Lyapunov exponents ordered:")') 
		write(1,'(" LE(",i6,")=",1x,f26.16)') (i,lamb_positivos(i),i=1,num_lyap_positive)
		write(*,'(" LE(",i6,")=",1x,f26.16)') (i,lamb_positivos(i),i=1,num_lyap_positive)
		write(1,'(" Sum of positive Lyapunov exponents= ",f26.16)') sum_pos_LEs
		write(*,'(" Sum of positive Lyapunov exponents= ",f26.16)') sum_pos_LEs
		write(1,'(" Number of positive Lyapunov exponents= ",i6)') num_lyap_positive
		write(*,'(" Number of positive Lyapunov exponents= ",i6)') num_lyap_positive
		if (num_lyapu>=2) then
			if (num_lyap_positive==1) then
				Ic=lamb_positivos(1)
				write(1,'(" Ic= ",f26.16," and number of positive Lyapunov exponents= ",i6)') Ic,num_lyap_positive
				write(*,'(" Ic= ",f26.16," and number of positive Lyapunov exponents= ",i6)') Ic,num_lyap_positive
			endif
			if (num_lyap_positive>=2) then
				Ic=lamb_positivos(1)-lamb_positivos(2)
				write(1,'(" Ic= ",f26.16," and number of positive Lyapunov exponents= ",i6)') Ic,num_lyap_positive
				write(*,'(" Ic= ",f26.16," and number of positive Lyapunov exponents= ",i6)') Ic,num_lyap_positive
			endif
		endif
		write(1,'(" ----------------------------------------------------------------------------------------------------------------------------------")')
		write(*,'(" ----------------------------------------------------------------------------------------------------------------------------------")')
		call flush(1)
	else
		write(1,'(//," No positive Lyapunov exponents found..!")')
		write(*,'(//," No positive Lyapunov exponents found..!")')
		call flush(1)
	endif
endif
	
!according to paper: J. S. Gomez-Gardenes et. al, PLOS ONE, vol. 5, issue 8, e12313, 2010
!computations of the global network synchronization measure in terms of the phase (for the whole network of num_neurons) ---> matriz_x(4,i),i=1,num_neurons
!and of the local synchronization of the clusters
!order_parameter_r_full_network/(t-trans_traj*dt) is the order parameter of the full network
order_parameter_r_full_network=order_parameter_r_full_network/(t-trans_traj*dt)
order_parameter_r_communities(:)=order_parameter_r_communities(:)/(t-trans_traj*dt)

if (syncmatrixglobalnetwork_switch==1) then
	syncmatrixglobalnetwork(:,:)=dsqrt((sumsin(:,:)*((matriz_acopla_electrical(:,:)+matriz_acopla_chemical(:,:))/(t-trans_traj*dt)))**2+(sumcos(:,:)*((matriz_acopla_electrical(:,:)+matriz_acopla_chemical(:,:))/(t-trans_traj*dt)))**2)
	!according to paper: J. S. Gomez-Gardenes et. al, PLOS ONE, vol. 5, issue 8, e12313, 2010
	!rlink is the fraction of all possible links that are synchronized in the network
	rlink=sum(syncmatrixglobalnetwork(:,:))/(sum(matriz_acopla_electrical(:,:)+matriz_acopla_chemical(:,:)))
endif

deallocate(matriz_par,matriz_x,guarda_x,matriz_cont)

if (num_lyapu>=1) deallocate(lamb_lyap,lamb_ordena,lamb_positivos)

deallocate(phase)
if (syncmatrixglobalnetwork_switch==1) deallocate(Deltaphase,sumsin,sumcos)

if (num_lyapu>=1) deallocate(ini2)

return
end subroutine bif_neuron_v12_mpi
