!------------------------------------------------------------
subroutine calc_lyap_1(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,ini2,dt,matriz_x,conta_grand_lyap,lamb_lyap,n_step,param_elec_coupling,conta_step_lyap,lyapu_on,matriz_acopla_chemical)
!1-stage Euler method
implicit none
integer(kind=4),intent(in)	:: num_lyapu,dim_par,system_dim,num_neurons,matriz_acopla_electrical(num_neurons,num_neurons),matriz_acopla_chemical(num_neurons,num_neurons),lyapu_on,n_step
real(kind=8),intent(in)		:: matriz_par(dim_par,num_neurons),matriz_x(system_dim,num_neurons),dt,param_elec_coupling
real(kind=8),intent(inout)	:: ini2(num_neurons*system_dim,num_lyapu),lamb_lyap(num_neurons*system_dim)
integer(kind=4),intent(inout)	:: conta_grand_lyap,conta_step_lyap
real(kind=8)			:: kk1(num_neurons*system_dim,num_lyapu),tra_x(num_neurons*system_dim,num_lyapu)

tra_x(:,:)=ini2(:,:)
call calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk1,matriz_x,param_elec_coupling,matriz_acopla_chemical)

ini2(:,:)=ini2(:,:)+dt*kk1(:,:)

!orthogonormalization ala Gram-Schmidt
call aux_lyap(num_lyapu,conta_grand_lyap,num_neurons,system_dim,ini2,lyapu_on,dt,lamb_lyap,conta_step_lyap,n_step)

return
end subroutine calc_lyap_1

!------------------------------------------------------------

subroutine calc_lyap_2(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,ini2,dt,matriz_x,conta_grand_lyap,lamb_lyap,n_step,param_elec_coupling,conta_step_lyap,lyapu_on,matriz_acopla_chemical)
!2-stage Heun method (or improved Euler method)
implicit none
integer(kind=4),intent(in)	:: num_lyapu,dim_par,system_dim,num_neurons,matriz_acopla_electrical(num_neurons,num_neurons),matriz_acopla_chemical(num_neurons,num_neurons),lyapu_on,n_step
real(kind=8),intent(in)		:: matriz_par(dim_par,num_neurons),matriz_x(system_dim,num_neurons),dt,param_elec_coupling
real(kind=8),intent(inout)	:: ini2(num_neurons*system_dim,num_lyapu),lamb_lyap(num_neurons*system_dim)
integer(kind=4),intent(inout)	:: conta_grand_lyap,conta_step_lyap
real(kind=8)			:: kk1(num_neurons*system_dim,num_lyapu),kk2(num_neurons*system_dim,num_lyapu),tra_x(num_neurons*system_dim,num_lyapu)

tra_x(:,:)=ini2(:,:)
call calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk1,matriz_x,param_elec_coupling,matriz_acopla_chemical)

tra_x(:,:)=ini2(:,:)+kk1(:,:)*dt
call calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk2,matriz_x,param_elec_coupling,matriz_acopla_chemical)

ini2(:,:)=ini2(:,:)+dt*(kk1(:,:)+kk2(:,:))/2.d0

!orthogonormalization ala Gram-Schmidt
call aux_lyap(num_lyapu,conta_grand_lyap,num_neurons,system_dim,ini2,lyapu_on,dt,lamb_lyap,conta_step_lyap,n_step)

return
end subroutine calc_lyap_2

!------------------------------------------------------------

subroutine calc_lyap_3(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,ini2,dt,matriz_x,conta_grand_lyap,lamb_lyap,n_step,param_elec_coupling,conta_step_lyap,lyapu_on,matriz_acopla_chemical)
!2-stage Arithmetic Mean Runge - Kutta method (3rd order)
implicit none
integer(kind=4),intent(in)	:: num_lyapu,dim_par,system_dim,num_neurons,matriz_acopla_electrical(num_neurons,num_neurons),matriz_acopla_chemical(num_neurons,num_neurons),lyapu_on,n_step
real(kind=8),intent(in)		:: matriz_par(dim_par,num_neurons),matriz_x(system_dim,num_neurons),dt,param_elec_coupling
real(kind=8),intent(inout)	:: ini2(num_neurons*system_dim,num_lyapu),lamb_lyap(num_neurons*system_dim)
integer(kind=4),intent(inout)	:: conta_grand_lyap,conta_step_lyap
real(kind=8)			:: kk1(num_neurons*system_dim,num_lyapu),kk2(num_neurons*system_dim,num_lyapu),kk3(num_neurons*system_dim,num_lyapu),tra_x(num_neurons*system_dim,num_lyapu)

tra_x(:,:)=ini2(:,:)
call calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk1,matriz_x,param_elec_coupling,matriz_acopla_chemical)

tra_x(:,:)=ini2(:,:)+0.5d0*kk1(:,:)*dt
call calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk2,matriz_x,param_elec_coupling,matriz_acopla_chemical)

tra_x(:,:)=ini2(:,:)+kk1(:,:)*dt
call calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk3,matriz_x,param_elec_coupling,matriz_acopla_chemical)

ini2(:,:)=ini2(:,:)+dt*(kk1(:,:)+4.d0*kk2(:,:)+kk3(:,:))/6.d0

!orthogonormalization ala Gram-Schmidt
call aux_lyap(num_lyapu,conta_grand_lyap,num_neurons,system_dim,ini2,lyapu_on,dt,lamb_lyap,conta_step_lyap,n_step)

return
end subroutine calc_lyap_3

!------------------------------------------------------------

subroutine calc_lyap_4(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,ini2,dt,matriz_x,conta_grand_lyap,lamb_lyap,n_step,param_elec_coupling,conta_step_lyap,lyapu_on,matriz_acopla_chemical)
!classic Runge - Kutta method (4th order)
implicit none
integer(kind=4),intent(in)	:: num_lyapu,dim_par,system_dim,num_neurons,matriz_acopla_electrical(num_neurons,num_neurons),matriz_acopla_chemical(num_neurons,num_neurons),lyapu_on,n_step
real(kind=8),intent(in)		:: matriz_par(dim_par,num_neurons),matriz_x(system_dim,num_neurons),dt,param_elec_coupling
real(kind=8),intent(inout)	:: ini2(num_neurons*system_dim,num_lyapu),lamb_lyap(num_neurons*system_dim)
integer(kind=4),intent(inout)	:: conta_grand_lyap,conta_step_lyap
real(kind=8)			:: kk1(num_neurons*system_dim,num_lyapu),kk2(num_neurons*system_dim,num_lyapu),kk3(num_neurons*system_dim,num_lyapu),kk4(num_neurons*system_dim,num_lyapu),tra_x(num_neurons*system_dim,num_lyapu)

tra_x(:,:)=ini2(:,:)
call calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk1,matriz_x,param_elec_coupling,matriz_acopla_chemical)

tra_x(:,:)=ini2(:,:)+0.5d0*kk1(:,:)*dt
call calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk2,matriz_x,param_elec_coupling,matriz_acopla_chemical)

tra_x(:,:)=ini2(:,:)+0.5d0*kk2(:,:)*dt
call calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk3,matriz_x,param_elec_coupling,matriz_acopla_chemical)

tra_x(:,:)=ini2(:,:)+kk3(:,:)*dt
call calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk4,matriz_x,param_elec_coupling,matriz_acopla_chemical)

ini2(:,:)=ini2(:,:)+dt*(kk1(:,:)+2.d0*(kk2(:,:)+kk3(:,:))+kk4(:,:))/6.d0

!orthogonormalization ala Gram-Schmidt
call aux_lyap(num_lyapu,conta_grand_lyap,num_neurons,system_dim,ini2,lyapu_on,dt,lamb_lyap,conta_step_lyap,n_step)

return
end subroutine calc_lyap_4

!------------------------------------------------------------

subroutine calc_k_lyapu(num_lyapu,dim_par,system_dim,num_neurons,matriz_par,matriz_acopla_electrical,tra_x,kk,matriz_x,param_elec_coupling,matriz_acopla_chemical)
implicit none
integer(kind=4),intent(in)	:: num_lyapu,dim_par,system_dim,num_neurons,matriz_acopla_electrical(num_neurons,num_neurons),matriz_acopla_chemical(num_neurons,num_neurons)
real(kind=8),intent(in)		:: matriz_par(dim_par,num_neurons),tra_x(num_neurons*system_dim,num_lyapu),matriz_x(system_dim,num_neurons),param_elec_coupling
real(kind=8),intent(inout)	:: kk(num_neurons*system_dim,num_lyapu)
real(kind=8)			:: acoplamento_chemical,numera,denomina,sp,sp_dot
integer(kind=4)			:: i,j,col

do col=1,num_lyapu
	do i=1,num_neurons
		acoplamento_chemical=0.d0
		kk((i-1)*system_dim+1,col)=(6.d0*matriz_x(1,i)-3.d0*matriz_x(1,i)**2)*tra_x((i-1)*system_dim+1,col)+tra_x((i-1)*system_dim+2,col)-tra_x((i-1)*system_dim+3,col) !for δp
		kk((i-1)*system_dim+2,col)=-10.d0*matriz_x(1,i)*tra_x((i-1)*system_dim+1,col)-tra_x((i-1)*system_dim+2,col) !for δq
		kk((i-1)*system_dim+3,col)=4.d0*matriz_par(4,i)*tra_x((i-1)*system_dim+1,col)-matriz_par(4,i)*tra_x((i-1)*system_dim+3,col) !for δn
		kk((i-1)*system_dim+4,col)=0.d0 !for δphase

		do j=1,num_neurons
			!electrical coupling
			if (matriz_acopla_electrical(i,j)==1) kk((i-1)*system_dim+1,col)=kk((i-1)*system_dim+1,col)+param_elec_coupling*(tra_x((j-1)*system_dim+1,col)-tra_x((i-1)*system_dim+1,col))

			!chemical coupling
			if (matriz_acopla_chemical(i,j)==1) then
				numera=dexp(-10.d0*(matriz_x(1,i)-matriz_par(6,i)))
				denomina=(1.d0+numera)**2
				sp=1.d0/(1.d0+numera)
				sp_dot=(10.d0*numera)/denomina
				
				acoplamento_chemical=matriz_par(3,i)*sp*tra_x((i-1)*system_dim+1,col)
		                kk((i-1)*system_dim+1,col)=kk((i-1)*system_dim+1,col)-acoplamento_chemical-matriz_par(3,i)*(matriz_x(1,i)-matriz_par(2,i))*sp_dot*tra_x((j-1)*system_dim+1,col)
			endif
		enddo
	enddo
enddo

return
end subroutine calc_k_lyapu

!------------------------------------------------------------

subroutine aux_lyap(num_lyapu,conta_grand_lyap,num_neurons,system_dim,ini2,lyapu_on,dt,lamb_lyap,conta_step_lyap,n_step)
implicit none
integer(kind=4),intent(in)	:: num_lyapu,num_neurons,system_dim,lyapu_on,n_step
integer(kind=4),intent(inout)	:: conta_step_lyap,conta_grand_lyap
real(kind=8),intent(in)		:: dt
real(kind=8),intent(inout)	:: lamb_lyap(num_lyapu),ini2(num_neurons*system_dim,num_lyapu)
real(kind=8)			:: mod_lyap(num_lyapu),mod_tran_lyap(num_lyapu),l2
parameter(l2=dlog(2.d0))
integer(kind=4)			:: i,j,n,jj,ko

conta_step_lyap=conta_step_lyap+1
if (conta_step_lyap>=n_step) then
	conta_step_lyap=0
	conta_grand_lyap=conta_grand_lyap+1

	mod_lyap(:)=0.d0

	mod_lyap(1)=dsqrt(sum(ini2(:,1)**2))

	!ortogonaliza vetor 1 e guarda em ini3 e em ini1
	ini2(:,1)=ini2(:,1)/mod_lyap(1)

	if (conta_grand_lyap>lyapu_on) lamb_lyap(1)=lamb_lyap(1)+(dlog(mod_lyap(1)))/(n_step*dt*l2)

	do n=2,num_lyapu
		do jj=1,n-1
			mod_tran_lyap(jj)=0.d0
			do ko=1,num_neurons*system_dim
				mod_tran_lyap(jj)=mod_tran_lyap(jj)+ini2(ko,n)*ini2(ko,jj)	
			enddo
		enddo
		do ko=1,num_neurons*system_dim
			do jj=1,n-1
				ini2(ko,n)=ini2(ko,n)-mod_tran_lyap(jj)*ini2(ko,jj)
			enddo
		enddo
		do ko=1,num_neurons*system_dim
			mod_lyap(n)=mod_lyap(n)+ini2(ko,n)**2
		enddo
		mod_lyap(n)=dsqrt(mod_lyap(n))	
		do ko=1,num_neurons*system_dim
			ini2(ko,n)=ini2(ko,n)/mod_lyap(n)
		enddo
		if (conta_grand_lyap>lyapu_on) lamb_lyap(n)=lamb_lyap(n)+(dlog(mod_lyap(n)))/(n_step*dt*l2)
	enddo
endif

return
end subroutine aux_lyap

!------------------------------------------------------------

subroutine swap_LEs(ndim,LE,LE_ordered)
implicit none
integer(kind=4),intent(in)	:: ndim
real(kind=8),intent(in)		:: LE(ndim)
real(kind=8),intent(out)	:: LE_ordered(ndim)
real(kind=8)			:: LE_tmp(ndim)
integer(kind=4)			:: i,k

LE_tmp=LE
do i=1,ndim
	do k=1,ndim-1
		if (LE_tmp(k)<LE_tmp(k+1)) call swap(ndim,LE_tmp,k,k+1)
	enddo
enddo
LE_ordered=LE_tmp

return
end subroutine swap_LEs

!------------------------------------------------------------

subroutine swap(ndim,vector,index_1,index_2)
implicit none
integer(kind=4),intent(in)	:: ndim,index_1,index_2
real(kind=8),intent(inout)	:: vector(ndim)
real(kind=8)			:: temp

temp=vector(index_1)
vector(index_1)=vector(index_2)
vector(index_2)=temp

return
end subroutine swap
!------------------------------------------------------------