filename='c-elegans_277'


set output 'local_clustering_coefficients_'.filename.'.eps'
set term postscript eps color enhanced font ",17"

set size 0.6,0.6

FIT_LIMIT = 1e-6
FIT_MAXITER = 0
!rm -rf fit.log
!rm -rf 'screen_output.out'

f(x) = a*x+b # define the function to be fitted
a = 1.021       ;       b = 1.0053654 # initial guess for a and b
fit [][] f(x) 'local_clustering_coefficients_'.filename.'.txt' using 1:2 via a, b
FIT_WSSR1=FIT_WSSR

stats filename.'.dat'
#show variables all

set xrange[0: 100*ceil(STATS_records/100.0)]
x_lim = 100*ceil(STATS_records/100.0)
set xrange[0: x_lim]
set xtics x_lim/4.0

set style line 1 lt 7 lw 4 linecolor rgb "black"
set style line 2 lt 5 lw 4 linecolor rgb "red"
set style line 3 lt 2 lw 4 linecolor rgb "blue"

set label 1 "a)" at graph 0.92, 0.93

set xtics add ("0" 0)

set xlabel 'node'
set ylabel 'CC(node)'

set key at graph 0.93, graph 0.95

plot [0:][-0.1:1.4] 'local_clustering_coefficients_'.filename.'.txt' u 1:2 ls 1 w p notitle, f(x) ls 2 w l title sprintf("slope=%6.4f",a), 'network_average_clustering_coefficients_gnuplot_'.filename.'.txt' u 1:2 w l ls 3 title "<CC(node)>"

print ''
print '-------------------------------------------------------------------------'
print '                       FINAL RESULTS FOLLOWS BELOW'
print '-------------------------------------------------------------------------'
print ''
print 'Parameters of the f(x) = a*x+b:'
print 'a= ',a;
print 'b= ',b;
print 'Final sum of squares of residuals= ',FIT_WSSR1;
print ''
